import { AbstractCrudObject } from './../abstract-crud-object';
import AbstractObject from './../abstract-object';
import Cursor from './../cursor';
import AdStudy from './ad-study';
import Business from './business';
import Post from './post';
import FundraiserPersonToCharity from './fundraiser-person-to-charity';
import GameItem from './game-item';
import LiveVideo from './live-video';
import Photo from './photo';
import AdVideo from './ad-video';
/**
 * User
 * @see {@link https://developers.facebook.com/docs/marketing-api/}
 */
export default class User extends AbstractCrudObject {
    static get Fields(): Readonly<{
        about: "about";
        age_range: "age_range";
        avatar_2d_profile_picture: "avatar_2d_profile_picture";
        birthday: "birthday";
        community: "community";
        cover: "cover";
        currency: "currency";
        education: "education";
        email: "email";
        favorite_athletes: "favorite_athletes";
        favorite_teams: "favorite_teams";
        first_name: "first_name";
        gender: "gender";
        hometown: "hometown";
        id: "id";
        id_for_avatars: "id_for_avatars";
        inspirational_people: "inspirational_people";
        install_type: "install_type";
        installed: "installed";
        is_guest_user: "is_guest_user";
        is_work_account: "is_work_account";
        languages: "languages";
        last_name: "last_name";
        link: "link";
        local_news_megaphone_dismiss_status: "local_news_megaphone_dismiss_status";
        local_news_subscription_status: "local_news_subscription_status";
        locale: "locale";
        location: "location";
        meeting_for: "meeting_for";
        middle_name: "middle_name";
        name: "name";
        name_format: "name_format";
        payment_pricepoints: "payment_pricepoints";
        political: "political";
        profile_pic: "profile_pic";
        quotes: "quotes";
        relationship_status: "relationship_status";
        shared_login_upgrade_required_by: "shared_login_upgrade_required_by";
        short_name: "short_name";
        significant_other: "significant_other";
        sports: "sports";
        supports_donate_button_in_live_video: "supports_donate_button_in_live_video";
        third_party_id: "third_party_id";
        timezone: "timezone";
        token_for_business: "token_for_business";
        updated_time: "updated_time";
        verified: "verified";
        video_upload_limits: "video_upload_limits";
        website: "website";
    }>;
    static get LocalNewsMegaphoneDismissStatus(): Readonly<{
        no: "NO";
        yes: "YES";
    }>;
    static get LocalNewsSubscriptionStatus(): Readonly<{
        status_off: "STATUS_OFF";
        status_on: "STATUS_ON";
    }>;
    static get Filtering(): Readonly<{
        ema: "ema";
        groups: "groups";
        groups_social: "groups_social";
    }>;
    static get Type(): Readonly<{
        content_update: "content_update";
        generic: "generic";
    }>;
    deleteAccessTokens(params?: Record<any, any>): Promise<any>;
    createAccessToken(fields: string[], params?: Record<any, any>, pathOverride?: string | null): Promise<User>;
    getAccounts(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getAccounts(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getAccounts(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    createAccount(fields: string[], params?: Record<any, any>, pathOverride?: string | null): Promise<AbstractObject>;
    getAdStudies(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getAdStudies(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getAdStudies(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    createAdStudy(fields: string[], params?: Record<any, any>, pathOverride?: string | null): Promise<AdStudy>;
    getAdAccounts(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getAdAccounts(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getAdAccounts(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    getAlbums(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getAlbums(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getAlbums(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    createApplication(fields: string[], params?: Record<any, any>, pathOverride?: string | null): Promise<User>;
    getAppRequestFormerRecipients(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getAppRequestFormerRecipients(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getAppRequestFormerRecipients(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    getAppRequests(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getAppRequests(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getAppRequests(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    getAssignedAdAccounts(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getAssignedAdAccounts(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getAssignedAdAccounts(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    getAssignedBusinessAssetGroups(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getAssignedBusinessAssetGroups(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getAssignedBusinessAssetGroups(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    getAssignedPages(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getAssignedPages(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getAssignedPages(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    getAssignedProductCatalogs(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getAssignedProductCatalogs(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getAssignedProductCatalogs(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    getAvatars(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getAvatars(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getAvatars(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    getBusinessUsers(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getBusinessUsers(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getBusinessUsers(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    deleteBusinesses(params?: Record<any, any>): Promise<any>;
    getBusinesses(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getBusinesses(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getBusinesses(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    createBusiness(fields: string[], params?: Record<any, any>, pathOverride?: string | null): Promise<Business>;
    getConversations(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getConversations(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getConversations(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    getCustomLabels(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getCustomLabels(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getCustomLabels(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    getEvents(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getEvents(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getEvents(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    getFeed(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getFeed(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getFeed(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    createFeed(fields: string[], params?: Record<any, any>, pathOverride?: string | null): Promise<Post>;
    getFriends(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getFriends(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getFriends(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    getFundraisers(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getFundraisers(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getFundraisers(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    createFundraiser(fields: string[], params?: Record<any, any>, pathOverride?: string | null): Promise<FundraiserPersonToCharity>;
    createGameItem(fields: string[], params?: Record<any, any>, pathOverride?: string | null): Promise<GameItem>;
    createGameTime(fields: string[], params?: Record<any, any>, pathOverride?: string | null): Promise<AbstractObject>;
    getGroups(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getGroups(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getGroups(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    getIdsForApps(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getIdsForApps(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getIdsForApps(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    getIdsForBusiness(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getIdsForBusiness(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getIdsForBusiness(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    getIdsForPages(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getIdsForPages(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getIdsForPages(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    getLikes(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getLikes(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getLikes(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    getLiveVideos(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getLiveVideos(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getLiveVideos(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    createLiveVideo(fields: string[], params?: Record<any, any>, pathOverride?: string | null): Promise<LiveVideo>;
    createMessengerDesktopPerformanceTrace(fields: string[], params?: Record<any, any>, pathOverride?: string | null): Promise<User>;
    getMusic(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getMusic(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getMusic(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    createNotification(fields: string[], params?: Record<any, any>, pathOverride?: string | null): Promise<User>;
    getPaymentTransactions(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getPaymentTransactions(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getPaymentTransactions(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    deletePermissions(params?: Record<any, any>): Promise<any>;
    getPermissions(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getPermissions(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getPermissions(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    getPersonalAdAccounts(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getPersonalAdAccounts(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getPersonalAdAccounts(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    getPhotos(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getPhotos(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getPhotos(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    createPhoto(fields: string[], params?: Record<any, any>, pathOverride?: string | null): Promise<Photo>;
    getPicture(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getPicture(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getPicture(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    getPosts(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getPosts(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getPosts(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    getRichMediaDocuments(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getRichMediaDocuments(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getRichMediaDocuments(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    createStagingResource(fields: string[], params?: Record<any, any>, pathOverride?: string | null): Promise<User>;
    getVideos(fields: string[], params?: Record<any, any>): Promise<Cursor>;
    getVideos(fields: string[], params: Record<any, any> | undefined, fetchFirstPage: false): Cursor;
    getVideos(fields: string[], params?: Record<any, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    createVideo(fields: string[], params?: Record<any, any>, pathOverride?: string | null): Promise<AdVideo>;
    delete(fields: string[], params?: Record<any, any>): Promise<AbstractObject>;
    get(fields: string[], params?: Record<any, any>): Promise<User>;
    update(fields: string[], params?: Record<any, any>): Promise<User>;
}
