// These definitions were initially written around 03-2021
// The files paths and folder structure are designed to resemble the Google Ads Scripts documentation website folder structure
// https://developers.google.com/google-ads/scripts/docs/reference/adsapp/adsapp

// Google Apps Script
/// <reference types="google-apps-script" />

// Google Ads Scripts
/// <reference path="./ads-app/ad-customizer/items.d.ts" />
/// <reference path="./ads-app/ad-customizer/sources.d.ts" />
/// <reference path="./ads-app/ad-extensions/callouts/account-callout.d.ts" />
/// <reference path="./ads-app/ad-extensions/callouts/ad-group-callout.d.ts" />
/// <reference path="./ads-app/ad-extensions/callouts/callout.d.ts" />
/// <reference path="./ads-app/ad-extensions/callouts/campaign-callout.d.ts" />
/// <reference path="./ads-app/ad-extensions/extension-schedule.d.ts" />
/// <reference path="./ads-app/ad-extensions/extensions.d.ts" />
/// <reference path="./ads-app/ad-extensions/messages/account-message.d.ts" />
/// <reference path="./ads-app/ad-extensions/messages/ad-group-message.d.ts" />
/// <reference path="./ads-app/ad-extensions/messages/campaign-message.d.ts" />
/// <reference path="./ads-app/ad-extensions/messages/message.d.ts" />
/// <reference path="./ads-app/ad-extensions/mobile-apps/account-mobile-app.d.ts" />
/// <reference path="./ads-app/ad-extensions/mobile-apps/ad-group-mobile-app.d.ts" />
/// <reference path="./ads-app/ad-extensions/mobile-apps/campaign-mobile-app.d.ts" />
/// <reference path="./ads-app/ad-extensions/mobile-apps/mobile-app.d.ts" />
/// <reference path="./ads-app/ad-extensions/phone-numbers/account-phone-number.d.ts" />
/// <reference path="./ads-app/ad-extensions/phone-numbers/ad-group-phone-number.d.ts" />
/// <reference path="./ads-app/ad-extensions/phone-numbers/campaign-phone-number.d.ts" />
/// <reference path="./ads-app/ad-extensions/phone-numbers/phone-number.d.ts" />
/// <reference path="./ads-app/ad-extensions/prices/account-price.d.ts" />
/// <reference path="./ads-app/ad-extensions/prices/ad-group-price.d.ts" />
/// <reference path="./ads-app/ad-extensions/prices/campaign-price.d.ts" />
/// <reference path="./ads-app/ad-extensions/prices/price-item.d.ts" />
/// <reference path="./ads-app/ad-extensions/prices/price.d.ts" />
/// <reference path="./ads-app/ad-extensions/sitelinks/account-sitelink.d.ts" />
/// <reference path="./ads-app/ad-extensions/sitelinks/ad-group-sitelink.d.ts" />
/// <reference path="./ads-app/ad-extensions/sitelinks/campaign-sitelink.d.ts" />
/// <reference path="./ads-app/ad-extensions/sitelinks/sitelink.d.ts" />
/// <reference path="./ads-app/ad-extensions/snippets/account-snippet.d.ts" />
/// <reference path="./ads-app/ad-extensions/snippets/ad-group-snippet.d.ts" />
/// <reference path="./ads-app/ad-extensions/snippets/campaign-snippet.d.ts" />
/// <reference path="./ads-app/ad-extensions/snippets/snippet.d.ts" />
/// <reference path="./ads-app/ad-groups/ad-group.d.ts" />
/// <reference path="./ads-app/ad-params/ad-param.d.ts" />
/// <reference path="./ads-app/ads/ad.d.ts" />
/// <reference path="./ads-app/ads/expanded-text-ad.d.ts" />
/// <reference path="./ads-app/ads/gmail-image-ad.d.ts" />
/// <reference path="./ads-app/ads/gmail-multi-product-ad.d.ts" />
/// <reference path="./ads-app/ads/gmail-single-promotion-ad.d.ts" />
/// <reference path="./ads-app/ads/html-5-ad.d.ts" />
/// <reference path="./ads-app/ads/image-ad.d.ts" />
/// <reference path="./ads-app/ads/policy-topic.d.ts" />
/// <reference path="./ads-app/ads/responsive-display-ad.d.ts" />
/// <reference path="./ads-app/ads/responsive-search-ad.d.ts" />
/// <reference path="./ads-app/ads-app.d.ts" />
/// <reference path="./ads-app/assets/ad-assets.d.ts" />
/// <reference path="./ads-app/assets/asset.d.ts" />
/// <reference path="./ads-app/bidding-strategies/bidding-strategy.d.ts" />
/// <reference path="./ads-app/budget-orders/billing-account.d.ts" />
/// <reference path="./ads-app/budget-orders/budget-order.d.ts" />
/// <reference path="./ads-app/budgets/budget.d.ts" />
/// <reference path="./ads-app/bulk-uploads/bulk-uploads.d.ts" />
/// <reference path="./ads-app/campaigns/campaign.d.ts" />
/// <reference path="./ads-app/common/account.d.ts" />
/// <reference path="./ads-app/common/execution-info.d.ts" />
/// <reference path="./ads-app/common/google-ads-date.d.ts" />
/// <reference path="./ads-app/common/stats.d.ts" />
/// <reference path="./ads-app/display/audiences/audience.d.ts" />
/// <reference path="./ads-app/display/audiences/excluded-audience.d.ts" />
/// <reference path="./ads-app/display/display.d.ts" />
/// <reference path="./ads-app/display/keywords/display-keyword.d.ts" />
/// <reference path="./ads-app/display/keywords/excluded-display-keyword.d.ts" />
/// <reference path="./ads-app/display/placements/excluded-placement.d.ts" />
/// <reference path="./ads-app/display/placements/placement.d.ts" />
/// <reference path="./ads-app/display/topics/excluded-topic.d.ts" />
/// <reference path="./ads-app/display/topics/topic.d.ts" />
/// <reference path="./ads-app/display/youtube-channels/excluded-youtube-channel.d.ts" />
/// <reference path="./ads-app/display/youtube-channels/youtube-channel.d.ts" />
/// <reference path="./ads-app/display/youtube-videos/excluded-youtube-video.d.ts" />
/// <reference path="./ads-app/display/youtube-videos/youtube-video.d.ts" />
/// <reference path="./ads-app/drafts/draft.d.ts" />
/// <reference path="./ads-app/experiments/experiment.d.ts" />
/// <reference path="./ads-app/keywords/keyword.d.ts" />
/// <reference path="./ads-app/labels/label.d.ts" />
/// <reference path="./ads-app/media/media.d.ts" />
/// <reference path="./ads-app/negative-keywords/negative-keyword.d.ts" />
/// <reference path="./ads-app/reports/report-row.d.ts" />
/// <reference path="./ads-app/reports/report.d.ts" />
/// <reference path="./ads-app/shared-sets/excluded-placement-lists/excluded-placement-list.d.ts" />
/// <reference path="./ads-app/shared-sets/excluded-placement-lists/shared-excluded-placement.d.ts" />
/// <reference path="./ads-app/shared-sets/negative-keyword-lists/negative-keyword-list.d.ts" />
/// <reference path="./ads-app/shared-sets/negative-keyword-lists/shared-negative-keyword.d.ts" />
/// <reference path="./ads-app/shopping/ad-groups/shopping-ad-group.d.ts" />
/// <reference path="./ads-app/shopping/ad-groups/targetting/audiences/shopping-ad-group-audience.d.ts" />
/// <reference path="./ads-app/shopping/campaigns/shopping-campaign.d.ts" />
/// <reference path="./ads-app/shopping/campaigns/targeting/audiences/shopping-campaign-audience.d.ts" />
/// <reference path="./ads-app/shopping/product-ads/product-ad.d.ts" />
/// <reference path="./ads-app/shopping/product-brands/product-brand.d.ts" />
/// <reference path="./ads-app/shopping/product-categories/product-category.d.ts" />
/// <reference path="./ads-app/shopping/product-channel-exclusivities/product-channel-exclusivity.d.ts" />
/// <reference path="./ads-app/shopping/product-channels/product-channel.d.ts" />
/// <reference path="./ads-app/shopping/product-conditions/product-condition.d.ts" />
/// <reference path="./ads-app/shopping/product-custom-labels/product-custom-label.d.ts" />
/// <reference path="./ads-app/shopping/product-groups/product-group.d.ts" />
/// <reference path="./ads-app/shopping/product-item-ids/product-item-id.d.ts" />
/// <reference path="./ads-app/shopping/product-types/product-type.d.ts" />
/// <reference path="./ads-app/targeting/ad-schedules/ad-schedule.d.ts" />
/// <reference path="./ads-app/targeting/audiences/search-ad-group-audience.d.ts" />
/// <reference path="./ads-app/targeting/audiences/search-ad-group-excluded-audience.d.ts" />
/// <reference path="./ads-app/targeting/audiences/search-audience-bidding.d.ts" />
/// <reference path="./ads-app/targeting/audiences/search-campaign-audience.d.ts" />
/// <reference path="./ads-app/targeting/audiences/search-campaign-excluded-audience.d.ts" />
/// <reference path="./ads-app/targeting/content-labels/excluded-content-label.d.ts" />
/// <reference path="./ads-app/targeting/excluded-locations/excluded-location.d.ts" />
/// <reference path="./ads-app/targeting/languages/language.d.ts" />
/// <reference path="./ads-app/targeting/locations/targeted-location.d.ts" />
/// <reference path="./ads-app/targeting/platforms/platform.d.ts" />
/// <reference path="./ads-app/targeting/proximities/address.d.ts" />
/// <reference path="./ads-app/targeting/proximities/targeted-proximity.d.ts" />
/// <reference path="./ads-app/targeting/targeting.d.ts" />
/// <reference path="./ads-app/user-lists/user-list.d.ts" />
/// <reference path="./ads-app/video/ad-groups/video-ad-group.d.ts" />
/// <reference path="./ads-app/video/ads/video-ad.d.ts" />
/// <reference path="./ads-app/video/campaigns/frequency-cap.d.ts" />
/// <reference path="./ads-app/video/campaigns/video-campaign.d.ts" />
/// <reference path="./ads-app/video/video-targeting/ages/excluded-video-age.d.ts" />
/// <reference path="./ads-app/video/video-targeting/ages/video-age.d.ts" />
/// <reference path="./ads-app/video/video-targeting/audiences/excluded-video-audience.d.ts" />
/// <reference path="./ads-app/video/video-targeting/audiences/video-audience.d.ts" />
/// <reference path="./ads-app/video/video-targeting/genders/excluded-video-gender.d.ts" />
/// <reference path="./ads-app/video/video-targeting/genders/video-gender.d.ts" />
/// <reference path="./ads-app/video/video-targeting/keywords/excluded-video-keyword.d.ts" />
/// <reference path="./ads-app/video/video-targeting/keywords/video-keyword.d.ts" />
/// <reference path="./ads-app/video/video-targeting/mobile-application-categories/excluded-video-mobile-app-category.d.ts" />
/// <reference path="./ads-app/video/video-targeting/mobile-application-categories/video-mobile-app-category.d.ts" />
/// <reference path="./ads-app/video/video-targeting/mobile-applications/excluded-video-mobile-application.d.ts" />
/// <reference path="./ads-app/video/video-targeting/mobile-applications/Video-mobile-application.d.ts" />
/// <reference path="./ads-app/video/video-targeting/parental-statuses/excluded-video-parental-status.d.ts" />
/// <reference path="./ads-app/video/video-targeting/parental-statuses/video-parental-status.d.ts" />
/// <reference path="./ads-app/video/video-targeting/placements/excluded-video-placement.d.ts" />
/// <reference path="./ads-app/video/video-targeting/placements/video-placement.d.ts" />
/// <reference path="./ads-app/video/video-targeting/topics/excluded-video-topic.d.ts" />
/// <reference path="./ads-app/video/video-targeting/topics/video-topic.d.ts" />
/// <reference path="./ads-app/video/video-targeting/video-criterion-bidding.d.ts" />
/// <reference path="./ads-app/video/video-targeting/video-targeting.d.ts" />
/// <reference path="./ads-app/video/video-targeting/youtube-channels/excluded-video-youtube-channel.d.ts" />
/// <reference path="./ads-app/video/video-targeting/youtube-channels/video-youtube-channel.d.ts" />
/// <reference path="./ads-app/video/video-targeting/youtube-videos/excluded-video-youtube-video.d.ts" />
/// <reference path="./ads-app/video/video-targeting/youtube-videos/video-youtube-video.d.ts" />
/// <reference path="./ads-manager-app/account-label/account-label.d.ts" />
/// <reference path="./ads-manager-app/ads-manager-app.d.ts" />
/// <reference path="./ads-manager-app/managed-account/managed-account.d.ts" />
/// <reference path="./base.d.ts" />
/// <reference path="./date-range.d.ts" />
