/// <reference types="node" />

interface Hash {
    update(value: string | number[] | ArrayBuffer | Buffer): Hash;
    digest(encoding?: undefined): ArrayBuffer;
    digest(encoding: "hex"): string;
}

interface RushaWorkerRequest {
    id: string;
    data: string | number[] | ArrayBuffer | Buffer | Blob;
}

interface RushaWorkerResponse {
    id: string;
    hash: string;
}

interface RushaWorker extends Worker {
    onmessage: ((this: RushaWorker, res: MessageEvent<RushaWorkerResponse>) => void) | null;
    postMessage(req: RushaWorkerRequest): void;
    terminate(): void;
}

interface Rusha {
    createHash(): Hash;
    createWorker(): RushaWorker;
    disableWorkerBehaviour(): void;
}

declare const Rusha: Rusha;

export = Rusha;
