interface TransformsOptions {
    modules?: boolean | undefined;
    /** Custom feature for stripping with from Vue render functions */
    stripWith?: boolean | undefined;
    /** Custom feature ensures with context targets functional render */
    stripWithFunctional?: boolean | undefined;
}

interface CompilerOptions {
    /** Selectively support some handy ES2015 features in templates */
    transforms?: TransformsOptions | undefined;
    /** Allow spread... */
    objectAssign?: string | undefined;
}

/**
 * Processes the raw render functions generated by `vue-template-compiler`
 */
declare function compiler(code: string, options?: CompilerOptions): string;
export = compiler;
