import { ComponentType, SVGProps } from "react";

declare namespace Dashicon {
    interface Props extends SVGProps<SVGSVGElement> {
        /**
         * ID of the dashicon to use.
         */
        icon: Icon;
        /**
         * Width of the icon (in pixels).
         * @defaultValue 20
         */
        size?: number | undefined;
    }
    type Icon =
        | "admin-appearance"
        | "admin-collapse"
        | "admin-comments"
        | "admin-customizer"
        | "admin-generic"
        | "admin-home"
        | "admin-links"
        | "admin-media"
        | "admin-multisite"
        | "admin-network"
        | "admin-page"
        | "admin-plugins"
        | "admin-post"
        | "admin-settings"
        | "admin-site"
        | "admin-site-alt"
        | "admin-site-alt2"
        | "admin-site-alt3"
        | "admin-tools"
        | "admin-users"
        | "airplane"
        | "album"
        | "align-center"
        | "align-full-width"
        | "align-left"
        | "align-none"
        | "align-pull-left"
        | "align-pull-right"
        | "align-right"
        | "align-wide"
        | "amazon"
        | "analytics"
        | "archive"
        | "arrow-down"
        | "arrow-down-alt"
        | "arrow-down-alt2"
        | "arrow-left"
        | "arrow-left-alt"
        | "arrow-left-alt2"
        | "arrow-right"
        | "arrow-right-alt"
        | "arrow-right-alt2"
        | "arrow-up"
        | "arrow-up-alt"
        | "arrow-up-alt2"
        | "art"
        | "awards"
        | "backup"
        | "bank"
        | "beer"
        | "bell"
        | "block-default"
        | "book"
        | "book-alt"
        | "buddicons-activity"
        | "buddicons-bbpress-logo"
        | "buddicons-buddypress-logo"
        | "buddicons-community"
        | "buddicons-forums"
        | "buddicons-friends"
        | "buddicons-groups"
        | "buddicons-pm"
        | "buddicons-replies"
        | "buddicons-topics"
        | "buddicons-tracking"
        | "building"
        | "businessman"
        | "businessperson"
        | "businesswoman"
        | "button"
        | "calculator"
        | "calendar"
        | "calendar-alt"
        | "camera"
        | "camera-alt"
        | "car"
        | "carrot"
        | "cart"
        | "category"
        | "chart-area"
        | "chart-bar"
        | "chart-line"
        | "chart-pie"
        | "clipboard"
        | "clock"
        | "cloud"
        | "cloud-saved"
        | "cloud-upload"
        | "code-standards"
        | "coffee"
        | "color-picker"
        | "columns"
        | "controls-back"
        | "controls-forward"
        | "controls-pause"
        | "controls-play"
        | "controls-repeat"
        | "controls-skipback"
        | "controls-skipforward"
        | "controls-volumeoff"
        | "controls-volumeon"
        | "cover-image"
        | "dashboard"
        | "database"
        | "database-add"
        | "database-export"
        | "database-import"
        | "database-remove"
        | "database-view"
        | "desktop"
        | "dismiss"
        | "download"
        | "drumstick"
        | "edit"
        | "edit-large"
        | "edit-page"
        | "editor-aligncenter"
        | "editor-alignleft"
        | "editor-alignright"
        | "editor-bold"
        | "editor-break"
        | "editor-code"
        | "editor-contract"
        | "editor-customchar"
        | "editor-expand"
        | "editor-help"
        | "editor-indent"
        | "editor-insertmore"
        | "editor-italic"
        | "editor-justify"
        | "editor-kitchensink"
        | "editor-ltr"
        | "editor-ol"
        | "editor-ol-rtl"
        | "editor-outdent"
        | "editor-paragraph"
        | "editor-paste-text"
        | "editor-paste-word"
        | "editor-quote"
        | "editor-removeformatting"
        | "editor-rtl"
        | "editor-spellcheck"
        | "editor-strikethrough"
        | "editor-table"
        | "editor-textcolor"
        | "editor-ul"
        | "editor-underline"
        | "editor-unlink"
        | "editor-video"
        | "ellipsis"
        | "email"
        | "email-alt"
        | "email-alt2"
        | "embed-audio"
        | "embed-generic"
        | "embed-photo"
        | "embed-post"
        | "embed-video"
        | "excerpt-view"
        | "exit"
        | "external"
        | "facebook"
        | "facebook-alt"
        | "feedback"
        | "filter"
        | "flag"
        | "food"
        | "format-aside"
        | "format-audio"
        | "format-chat"
        | "format-gallery"
        | "format-image"
        | "format-quote"
        | "format-status"
        | "format-video"
        | "forms"
        | "fullscreen-alt"
        | "fullscreen-exit-alt"
        | "games"
        | "google"
        | "grid-view"
        | "groups"
        | "hammer"
        | "heading"
        | "heart"
        | "hidden"
        | "hourglass"
        | "html"
        | "id"
        | "id-alt"
        | "image-crop"
        | "image-filter"
        | "image-flip-horizontal"
        | "image-flip-vertical"
        | "image-rotate"
        | "image-rotate-left"
        | "image-rotate-right"
        | "images-alt"
        | "images-alt2"
        | "index-card"
        | "info"
        | "info-outline"
        | "insert"
        | "insert-after"
        | "insert-before"
        | "instagram"
        | "laptop"
        | "layout"
        | "leftright"
        | "lightbulb"
        | "linkedin"
        | "list-view"
        | "location"
        | "location-alt"
        | "lock"
        | "marker"
        | "media-archive"
        | "media-audio"
        | "media-code"
        | "media-default"
        | "media-document"
        | "media-interactive"
        | "media-spreadsheet"
        | "media-text"
        | "media-video"
        | "megaphone"
        | "menu"
        | "menu-alt"
        | "menu-alt2"
        | "menu-alt3"
        | "microphone"
        | "migrate"
        | "minus"
        | "money"
        | "money-alt"
        | "move"
        | "nametag"
        | "networking"
        | "no"
        | "no-alt"
        | "open-folder"
        | "palmtree"
        | "paperclip"
        | "pdf"
        | "performance"
        | "pets"
        | "phone"
        | "pinterest"
        | "playlist-audio"
        | "playlist-video"
        | "plugins-checked"
        | "plus"
        | "plus-alt"
        | "plus-alt2"
        | "podio"
        | "portfolio"
        | "post-status"
        | "pressthis"
        | "printer"
        | "privacy"
        | "products"
        | "randomize"
        | "reddit"
        | "redo"
        | "remove"
        | "rest-api"
        | "rss"
        | "saved"
        | "schedule"
        | "screenoptions"
        | "search"
        | "share"
        | "share-alt"
        | "share-alt2"
        | "shield"
        | "shield-alt"
        | "shortcode"
        | "slides"
        | "smartphone"
        | "smiley"
        | "sort"
        | "sos"
        | "spotify"
        | "star-empty"
        | "star-filled"
        | "star-half"
        | "sticky"
        | "store"
        | "superhero"
        | "superhero-alt"
        | "table-col-after"
        | "table-col-before"
        | "table-col-delete"
        | "table-row-after"
        | "table-row-before"
        | "table-row-delete"
        | "tablet"
        | "tag"
        | "tagcloud"
        | "testimonial"
        | "text"
        | "text-page"
        | "thumbs-down"
        | "thumbs-up"
        | "tickets"
        | "tickets-alt"
        | "tide"
        | "translation"
        | "trash"
        | "twitch"
        | "twitter"
        | "twitter-alt"
        | "undo"
        | "universal-access"
        | "universal-access-alt"
        | "unlock"
        | "update"
        | "update-alt"
        | "upload"
        | "vault"
        | "video-alt"
        | "video-alt2"
        | "video-alt3"
        | "visibility"
        | "warning"
        | "welcome-add-page"
        | "welcome-comments"
        | "welcome-learn-more"
        | "welcome-view-site"
        | "welcome-widgets-menus"
        | "welcome-write-blog"
        | "whatsapp"
        | "wordpress"
        | "wordpress-alt"
        | "xing"
        | "yes"
        | "yes-alt"
        | "youtube";
}
declare const Dashicon: ComponentType<Dashicon.Props>;

export default Dashicon;
