import English = require("./English");
import Language = require("./Language");

declare namespace Spanish {
    interface Vocabulary extends English.Vocabulary {
        sea: string;
        sean: string;
        dado: string;
        dada: string;
        dados: string;
        dadas: string;
        cuando: string;
        si: string;
        entonces: string;
    }

    interface Library extends English.Library {
        sea(step: string | string[] | RegExp | RegExp[], fn: (...args: string[]) => Promise<void>): this;
        sea(
            step: string | string[] | RegExp | RegExp[],
            fn: (
                arg1: string,
                arg2: string,
                arg3: string,
                arg4: string,
                arg5: string,
                arg6: string,
                next: (err?: Error) => void,
            ) => void,
        ): this;
        sea(
            step: string | string[] | RegExp | RegExp[],
            fn: (
                arg1: string,
                arg2: string,
                arg3: string,
                arg4: string,
                arg5: string,
                next: (err?: Error) => void,
            ) => void,
        ): this;
        sea(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, arg2: string, arg3: string, arg4: string, next: (err?: Error) => void) => void,
        ): this;
        sea(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, arg2: string, arg3: string, next: (err?: Error) => void) => void,
        ): this;
        sea(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, arg2: string, next: (err?: Error) => void) => void,
        ): this;
        sea(step: string | string[] | RegExp | RegExp[], fn: (arg1: string, next: (err?: Error) => void) => void): this;
        sea(step: string | string[] | RegExp | RegExp[], fn: (next: (err?: Error) => void) => void): this;
        sean(step: string | string[] | RegExp | RegExp[], fn: (...args: string[]) => Promise<void>): this;
        sean(
            step: string | string[] | RegExp | RegExp[],
            fn: (
                arg1: string,
                arg2: string,
                arg3: string,
                arg4: string,
                arg5: string,
                arg6: string,
                next: (err?: Error) => void,
            ) => void,
        ): this;
        sean(
            step: string | string[] | RegExp | RegExp[],
            fn: (
                arg1: string,
                arg2: string,
                arg3: string,
                arg4: string,
                arg5: string,
                next: (err?: Error) => void,
            ) => void,
        ): this;
        sean(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, arg2: string, arg3: string, arg4: string, next: (err?: Error) => void) => void,
        ): this;
        sean(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, arg2: string, arg3: string, next: (err?: Error) => void) => void,
        ): this;
        sean(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, arg2: string, next: (err?: Error) => void) => void,
        ): this;
        sean(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, next: (err?: Error) => void) => void,
        ): this;
        sean(step: string | string[] | RegExp | RegExp[], fn: (next: (err?: Error) => void) => void): this;
        dado(step: string | string[] | RegExp | RegExp[], fn: (...args: string[]) => Promise<void>): this;
        dado(
            step: string | string[] | RegExp | RegExp[],
            fn: (
                arg1: string,
                arg2: string,
                arg3: string,
                arg4: string,
                arg5: string,
                arg6: string,
                next: (err?: Error) => void,
            ) => void,
        ): this;
        dado(
            step: string | string[] | RegExp | RegExp[],
            fn: (
                arg1: string,
                arg2: string,
                arg3: string,
                arg4: string,
                arg5: string,
                next: (err?: Error) => void,
            ) => void,
        ): this;
        dado(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, arg2: string, arg3: string, arg4: string, next: (err?: Error) => void) => void,
        ): this;
        dado(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, arg2: string, arg3: string, next: (err?: Error) => void) => void,
        ): this;
        dado(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, arg2: string, next: (err?: Error) => void) => void,
        ): this;
        dado(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, next: (err?: Error) => void) => void,
        ): this;
        dado(step: string | string[] | RegExp | RegExp[], fn: (next: (err?: Error) => void) => void): this;
        dada(step: string | string[] | RegExp | RegExp[], fn: (...args: string[]) => Promise<void>): this;
        dada(
            step: string | string[] | RegExp | RegExp[],
            fn: (
                arg1: string,
                arg2: string,
                arg3: string,
                arg4: string,
                arg5: string,
                arg6: string,
                next: (err?: Error) => void,
            ) => void,
        ): this;
        dada(
            step: string | string[] | RegExp | RegExp[],
            fn: (
                arg1: string,
                arg2: string,
                arg3: string,
                arg4: string,
                arg5: string,
                next: (err?: Error) => void,
            ) => void,
        ): this;
        dada(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, arg2: string, arg3: string, arg4: string, next: (err?: Error) => void) => void,
        ): this;
        dada(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, arg2: string, arg3: string, next: (err?: Error) => void) => void,
        ): this;
        dada(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, arg2: string, next: (err?: Error) => void) => void,
        ): this;
        dada(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, next: (err?: Error) => void) => void,
        ): this;
        dada(step: string | string[] | RegExp | RegExp[], fn: (next: (err?: Error) => void) => void): this;
        dados(step: string | string[] | RegExp | RegExp[], fn: (...args: string[]) => Promise<void>): this;
        dados(
            step: string | string[] | RegExp | RegExp[],
            fn: (
                arg1: string,
                arg2: string,
                arg3: string,
                arg4: string,
                arg5: string,
                arg6: string,
                next: (err?: Error) => void,
            ) => void,
        ): this;
        dados(
            step: string | string[] | RegExp | RegExp[],
            fn: (
                arg1: string,
                arg2: string,
                arg3: string,
                arg4: string,
                arg5: string,
                next: (err?: Error) => void,
            ) => void,
        ): this;
        dados(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, arg2: string, arg3: string, arg4: string, next: (err?: Error) => void) => void,
        ): this;
        dados(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, arg2: string, arg3: string, next: (err?: Error) => void) => void,
        ): this;
        dados(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, arg2: string, next: (err?: Error) => void) => void,
        ): this;
        dados(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, next: (err?: Error) => void) => void,
        ): this;
        dados(step: string | string[] | RegExp | RegExp[], fn: (next: (err?: Error) => void) => void): this;
        dadas(step: string | string[] | RegExp | RegExp[], fn: (...args: string[]) => Promise<void>): this;
        dadas(
            step: string | string[] | RegExp | RegExp[],
            fn: (
                arg1: string,
                arg2: string,
                arg3: string,
                arg4: string,
                arg5: string,
                arg6: string,
                next: (err?: Error) => void,
            ) => void,
        ): this;
        dadas(
            step: string | string[] | RegExp | RegExp[],
            fn: (
                arg1: string,
                arg2: string,
                arg3: string,
                arg4: string,
                arg5: string,
                next: (err?: Error) => void,
            ) => void,
        ): this;
        dadas(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, arg2: string, arg3: string, arg4: string, next: (err?: Error) => void) => void,
        ): this;
        dadas(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, arg2: string, arg3: string, next: (err?: Error) => void) => void,
        ): this;
        dadas(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, arg2: string, next: (err?: Error) => void) => void,
        ): this;
        dadas(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, next: (err?: Error) => void) => void,
        ): this;
        dadas(step: string | string[] | RegExp | RegExp[], fn: (next: (err?: Error) => void) => void): this;
        cuando(step: string | string[] | RegExp | RegExp[], fn: (...args: string[]) => Promise<void>): this;
        cuando(
            step: string | string[] | RegExp | RegExp[],
            fn: (
                arg1: string,
                arg2: string,
                arg3: string,
                arg4: string,
                arg5: string,
                arg6: string,
                next: (err?: Error) => void,
            ) => void,
        ): this;
        cuando(
            step: string | string[] | RegExp | RegExp[],
            fn: (
                arg1: string,
                arg2: string,
                arg3: string,
                arg4: string,
                arg5: string,
                next: (err?: Error) => void,
            ) => void,
        ): this;
        cuando(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, arg2: string, arg3: string, arg4: string, next: (err?: Error) => void) => void,
        ): this;
        cuando(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, arg2: string, arg3: string, next: (err?: Error) => void) => void,
        ): this;
        cuando(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, arg2: string, next: (err?: Error) => void) => void,
        ): this;
        cuando(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, next: (err?: Error) => void) => void,
        ): this;
        cuando(step: string | string[] | RegExp | RegExp[], fn: (next: (err?: Error) => void) => void): this;
        si(step: string | string[] | RegExp | RegExp[], fn: (...args: string[]) => Promise<void>): this;
        si(
            step: string | string[] | RegExp | RegExp[],
            fn: (
                arg1: string,
                arg2: string,
                arg3: string,
                arg4: string,
                arg5: string,
                arg6: string,
                next: (err?: Error) => void,
            ) => void,
        ): this;
        si(
            step: string | string[] | RegExp | RegExp[],
            fn: (
                arg1: string,
                arg2: string,
                arg3: string,
                arg4: string,
                arg5: string,
                next: (err?: Error) => void,
            ) => void,
        ): this;
        si(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, arg2: string, arg3: string, arg4: string, next: (err?: Error) => void) => void,
        ): this;
        si(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, arg2: string, arg3: string, next: (err?: Error) => void) => void,
        ): this;
        si(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, arg2: string, next: (err?: Error) => void) => void,
        ): this;
        si(step: string | string[] | RegExp | RegExp[], fn: (arg1: string, next: (err?: Error) => void) => void): this;
        si(step: string | string[] | RegExp | RegExp[], fn: (next: (err?: Error) => void) => void): this;
        entonces(step: string | string[] | RegExp | RegExp[], fn: (...args: string[]) => Promise<void>): this;
        entonces(
            step: string | string[] | RegExp | RegExp[],
            fn: (
                arg1: string,
                arg2: string,
                arg3: string,
                arg4: string,
                arg5: string,
                arg6: string,
                next: (err?: Error) => void,
            ) => void,
        ): this;
        entonces(
            step: string | string[] | RegExp | RegExp[],
            fn: (
                arg1: string,
                arg2: string,
                arg3: string,
                arg4: string,
                arg5: string,
                next: (err?: Error) => void,
            ) => void,
        ): this;
        entonces(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, arg2: string, arg3: string, arg4: string, next: (err?: Error) => void) => void,
        ): this;
        entonces(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, arg2: string, arg3: string, next: (err?: Error) => void) => void,
        ): this;
        entonces(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, arg2: string, next: (err?: Error) => void) => void,
        ): this;
        entonces(
            step: string | string[] | RegExp | RegExp[],
            fn: (arg1: string, next: (err?: Error) => void) => void,
        ): this;
        entonces(step: string | string[] | RegExp | RegExp[], fn: (next: (err?: Error) => void) => void): this;
    }
}

declare const Spanish: Language<Spanish.Library>;

export = Spanish;
